## ardour 6.5.0+ds0

=== wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options
import os
import re
import string
import subprocess
import sys
import platform as PLATFORM
from waflib.Tools import winres
from waflib.Build import Context
from waflib.Build import BuildContext

# Fixup OSX 10.5/10.6 builds
# prefer gcc, g++ 4.x over ancient clang-1.5
from waflib.Tools.compiler_c import c_compiler
from waflib.Tools.compiler_cxx import cxx_compiler
c_compiler['darwin'] = ['gcc', 'clang' ]
cxx_compiler['darwin'] = ['g++', 'clang++' ]

class i18n(BuildContext):
        cmd = 'i18n'
        fun = 'i18n'

class i18n_pot(BuildContext):
        cmd = 'i18n_pot'
        fun = 'i18n_pot'

class i18n_po(BuildContext):
        cmd = 'i18n_po'
        fun = 'i18n_po'

class i18n_mo(BuildContext):
        cmd = 'i18n_mo'
        fun = 'i18n_mo'

compiler_flags_dictionaries= {
    'gcc' : {
        # Flags required when building a debug build
        'debuggable' : [ '-g' ],
        # Flags required for the linker (if any) when building a debug build
        'linker-debuggable' : '',
        # Flags required when building a non-debug optimized build
        'nondebuggable' : '-DNDEBUG',
        # Flags required to enable profiling at runtime with optimized builds
        'profile' : [ '-fno-omit-frame-pointer' ],
        # Flags required to enable gprofile profiling
        'gprofile' : '-pg',
        # Flags required to disable warnings about unused arguments to function calls
        'silence-unused-arguments' : '',
        # Flags required to use SSE unit for general math
        'sse' : '-msse',
        # Flags required to use SSE unit for floating point math
        'fpmath-sse' : '-mfpmath=sse',
        # Flags required to use _xgetbv with mingw+gcc > 8.2
        'xsaveintrin' : '-mxsave',
        # Flags required to use XMM Intrinsics
        'xmmintrinsics' : '-DUSE_XMMINTRIN',
        # Flags to use posix pipes between compiler stages
        'pipe' : '-pipe',
        # Flags for maximally optimized build
        'full-optimization' : [ '-O3', '-fomit-frame-pointer', '-ffast-math', '-fstrength-reduce' ],
        # Flag to ensure that compiler error output includes column/line numbers
        'show-column' : '-fshow-column',
        # Flags required to build for x86 only (OS X feature)
        'generic-x86' : '',
        # Flags required to build for PowerPC only (OS X feature)
        'generic-ppc' : '',
        # All flags required to get basic warnings to be generated by the compiler
        'basic-warnings' : [ '-Wall', '-Wpointer-arith', '-Wcast-qual', '-Wcast-align', '-Wno-unused-parameter' ],
        # Any additional flags for warnings that are specific to C (not C++)
        'extra-c-warnings' : [ '-Wstrict-prototypes', '-Wmissing-prototypes' ],
        # Any additional flags for warnings that are specific to C++ (not C)
        'extra-cxx-warnings' : [ '-Woverloaded-virtual', '-Wno-unused-local-typedefs' ],
        # Flags used for "strict" compilation, C and C++ (i.e. compiler will warn about language issues)
        'strict' : ['-Wall', '-Wcast-align', '-Wextra', '-Wwrite-strings', '-Wunsafe-loop-optimizations', '-Wlogical-op' ],
        # Flags used for "strict" compilation, C only (i.e. compiler will warn about language issues)
        'c-strict' : ['-std=c99', '-pedantic', '-Wshadow'],
        # Flags used for "strict" compilation, C++ only (i.e. compiler will warn about language issues)
        'cxx-strict' : [ '-ansi', '-Wnon-virtual-dtor', '-Woverloaded-virtual', '-fstrict-overflow' ],
        # Flags required for whatever consider the strictest possible compilation
        'ultra-strict' : ['-Wredundant-decls', '-Wstrict-prototypes', '-Wmissing-prototypes'],
        # Flag to turn on C99 compliance by itself
        'c99': '-std=c99',
        # Flag to enable AT&T assembler syntax
        'attasm': '-masm=att',
        # Flags to make AVX instructions/intrinsics available
        'avx': '-mavx',
        # Flags to make ARM/NEON instructions/intrinsics available
        'neon': '-mfpu=neon',
        # Flags to generate position independent code, when needed to build a shared object
        'pic': '-fPIC',
        # Flags required to compile C code with anonymous unions (only part of C11)
        'c-anonymous-union': '-fms-extensions',
    },
    'msvc' : {
        'debuggable' : ['/DDEBUG', '/Od', '/Zi', '/MDd', '/Gd', '/EHsc'],
        'linker-debuggable' : ['/DEBUG', '/INCREMENTAL' ],
        'nondebuggable' : ['/DNDEBUG', '/Ob1', '/MD', '/Gd', '/EHsc'],
        'profile' : '/Oy-',
        'sse' : '/arch:SSE',
        'silence-unused-arguments' : '',
        'sse' : '',
        'xsaveintrin' : '',
        'fpmath-sse' : '',
        'xmmintrinsics' : '',
        'pipe' : '',
        'full-optimization' : '/O2',
        'no-frame-pointer' : '',
        'fast-math' : '',
        'strength-reduce' : '',
        'show-column' : '',
        'generic-x86' : '',
        'generic-ppc' : '',
        'basic-warnings' : '',
        'extra-c-warnings' : '',
        'extra-cxx-warnings' : '',
        'ultra-strict' : '',
        'c-strict' : '',
        'cxx-strict' : '',
        'strict' : '',
        'c99': '/TP',
        'attasm': '',
        'avx': '',
        'neon': '',
        'pic': '',
        'c-anonymous-union': '',
    },
}

# Copy, edit and insert variants on gcc dict for gcc-darwin and clang

gcc_darwin_dict = compiler_flags_dictionaries['gcc'].copy()
gcc_darwin_dict['extra-cxx-warnings'] = [ '-Woverloaded-virtual' ]
gcc_darwin_dict['cxx-strict'] = [ '-ansi', '-Wnon-virtual-dtor', '-Woverloaded-virtual' ]
gcc_darwin_dict['strict'] = ['-Wall', '-Wcast-align', '-Wextra', '-Wwrite-strings' ]
gcc_darwin_dict['generic-x86'] = [ '-arch', 'i386' ]
gcc_darwin_dict['generic-ppc'] = [ '-arch', 'ppc' ]
compiler_flags_dictionaries['gcc-darwin'] = gcc_darwin_dict;

clang_dict = compiler_flags_dictionaries['gcc'].copy();
clang_dict['sse'] = ''
clang_dict['fpmath-sse'] = ''
clang_dict['xsaveintrin'] = ''
clang_dict['xmmintrinsics'] = ''
clang_dict['silence-unused-arguments'] = '-Qunused-arguments'
clang_dict['extra-cxx-warnings'] = [ '-Woverloaded-virtual', '-Wno-mismatched-tags', '-Wno-cast-align', '-Wno-unused-local-typedefs', '-Wunneeded-internal-declaration' ]
clang_dict['cxx-strict'] = [ '-ansi', '-Wnon-virtual-dtor', '-Woverloaded-virtual', '-fstrict-overflow' ]
clang_dict['strict'] = ['-Wall', '-Wcast-align', '-Wextra', '-Wwrite-strings' ]
clang_dict['generic-x86'] = [ '-arch', 'i386' ]
clang_dict['full-optimization'] = [ '-O3', '-fomit-frame-pointer', '-ffast-math', ]
compiler_flags_dictionaries['clang'] = clang_dict;

clang_darwin_dict = compiler_flags_dictionaries['clang'].copy();
clang_darwin_dict['cxx-strict'] = [ '-ansi', '-Wnon-virtual-dtor', '-Woverloaded-virtual', ]
clang_darwin_dict['full-optimization'] = [ '-O3', '-ffast-math']
compiler_flags_dictionaries['clang-darwin'] = clang_darwin_dict;

def fetch_git_revision_date ():
    cmd = ["git", "describe", "HEAD"]
    output = subprocess.Popen(cmd, stderr=subprocess.STDOUT, stdout=subprocess.PIPE).communicate()[0].splitlines()
    rev = re.sub(r"^[A-Za-z0-9]*\+", "", output[0].decode('utf-8'))

    cmd = ["git", "log", "-1", "--pretty=format:%ci", "HEAD"]
    output = subprocess.Popen(cmd, stderr=subprocess.STDOUT, stdout=subprocess.PIPE).communicate()[0].splitlines()
    date = output[0].decode('utf-8').split(None, 2)[0]

    return rev, date

def fetch_tarball_revision_date():
    if not os.path.exists ('libs/ardour/revision.cc'):
        print ('This tarball was not created correctly - it is missing libs/ardour/revision.cc')
        sys.exit (1)
    with open('libs/ardour/revision.cc', 'rb') as f:
        content = f.readlines()
        remove_punctuation_map = dict((ord(char), None) for char in '";')

        raw_line_tokens = content[1].decode('utf-8').strip().split(' ')
        rev = raw_line_tokens[7].translate(remove_punctuation_map)
        date = raw_line_tokens[12].translate(remove_punctuation_map)

        return rev, date

if os.path.isdir (os.path.join(os.getcwd(), '.git')):
    rev, rev_date = fetch_git_revision_date()
else:
    rev, rev_date = fetch_tarball_revision_date()

#
# rev is now of the form MAJOR.MINOR[-rcX]-rev-commit
# or, if right at the same rev as a release, MAJOR.MINOR[-rcX]
#

parts = rev.split ('.', 1)
MAJOR = parts[0]
other = parts[1].split('-', 1)
MINOR = other[0]
if len(other) > 1:
    MICRO = other[1].rsplit('-',1)[0].replace('-','.')
else:
    MICRO = '0'

V = MAJOR + '.' + MINOR + '.' + MICRO

def sanitize(s):
    # round-trip to remove anything in the string that is not encodable in
    # ASCII, yet still keep a real (utf8-encoded internally) string.
    s = s.encode ('ascii', 'ignore').decode ("utf-8")
    # In Python3, bytes is the class of binary content and encode() returns
    # bytes to transform a string according to a text encoding; str is the
    # class of normal strings (utf8-encoded internally) and decode() returns
    # that type.
    # Python 2 did not initially cater for encoding problems and can use str
    # for both binary content and for (decoded) strings. The Unicode type was
    # added to correspond to Python 3 str, and the Python 2 str type should
    # only correspond to bytes. Alas, almost everything in the Python 2
    # ecosystem has been written with str in mind and doesn't handle Unicode
    # objects correctly. If Python 2 is in use, s will be a Unicode object and
    # to avoid strange problems later we convert back to str, but in utf-8
    # nonetheless.
    if not isinstance(s, str):
        s = s.encode("utf-8")
    return s
VERSION = sanitize(V)
PROGRAM_VERSION = sanitize(MAJOR)
del sanitize

if any(arg in ('dist', 'distcheck') for arg in sys.argv[1:]):
        if not 'APPNAME' in os.environ:
                print ("You must define APPNAME in the environment when running ./waf dist/distcheck")
                sys.exit (1)
        APPNAME = os.environ['APPNAME'];

# Mandatory variables
top = '.'
out = 'build'

children = [
        # optionally external libraries
        'libs/fluidsynth',
        'libs/hidapi',
        'libs/libltc',
        'libs/lua',
        'libs/ptformat',
        'libs/qm-dsp',
        'libs/vamp-plugins',
        'libs/vamp-pyin',
        'libs/zita-resampler',
        'libs/zita-convolver',
        # core ardour libraries
        'libs/pbd',
        'libs/midi++2',
        'libs/evoral',
        'libs/surfaces',
        'libs/panners',
        'libs/backends',
        'libs/temporal',
        'libs/ardour',
        'libs/gtkmm2ext',
        'libs/audiographer',
        'libs/canvas',
        'libs/widgets',
        'libs/waveview',
        'libs/plugins/reasonablesynth.lv2',
        'libs/plugins/a-comp.lv2',
        'libs/plugins/a-exp.lv2',
        'libs/plugins/a-delay.lv2',
        'libs/plugins/a-eq.lv2',
        'libs/plugins/a-reverb.lv2',
        'libs/plugins/a-fluidsynth.lv2',
        'gtk2_ardour',
        'share/export',
        'share/midi_maps',
        'share/mcp',
        'share/osc',
        'share/patchfiles',
        'share/plugin_metadata',
        'share/scripts',
        'share/web_surfaces',
        'headless',
        'luasession',
        'session_utils',
        # shared helper binaries (plugin-scanner, exec-wrapper)
        'libs/fst',
        'libs/vfork',
        'libs/ardouralsautil',
]

i18n_children = [
        'gtk2_ardour',
        'libs/ardour',
        'libs/gtkmm2ext',
]

# Version stuff

def fetch_gcc_version (CC):
    cmd = "%s --version" % CC
    output = subprocess.Popen(cmd, shell=True, stderr=subprocess.STDOUT, stdout=subprocess.PIPE).communicate()[0].splitlines()
    o = output[0].decode('utf-8')
    version = o.split(' ')[2].split('.')
    return version

def create_stored_revision():
    rev = ""
    if os.path.exists('.git'):
        rev, rev_date = fetch_git_revision_date();
        print("Git version: " + rev + "\n")

=== gtk2_ardour/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options, TaskGen
import waflib.Logs as Logs, waflib.Utils as Utils
import os
import shutil
import sys
import re
import time
from waflib.Task import Task
from waflib.Tools import winres
import subprocess
import glob
import copy

# Mandatory variables
top = '.'
out = 'build'

from waflib import TaskGen
@TaskGen.extension('.m')
def m_hook(self, node):
	"""Alias .m files to be compiled the same as .c files, gcc will do the right thing."""
	return self.create_compiled_task('c', node)

path_prefix = 'gtk2_ardour/'

gtk2_ardour_sources = [
        'about.cc',
        'actions.cc',
        'add_route_dialog.cc',
        'ambiguous_file_dialog.cc',
        'analysis_window.cc',
        'ardour_dialog.cc',
        'ardour_http.cc',
        'ardour_message.cc',
        'ardour_ui.cc',
        'ardour_ui2.cc',
        'ardour_ui3.cc',
        'ardour_ui_access_web.cc',
        'ardour_ui_dependents.cc',
        'ardour_ui_dialogs.cc',
        'ardour_ui_ed.cc',
        'ardour_ui_engine.cc',
        'ardour_ui_keys.cc',
        'ardour_ui_mixer.cc',
        'ardour_ui_options.cc',
        'ardour_ui_session.cc',
        'ardour_ui_startup.cc',
        'ardour_ui_video.cc',
        'ardour_window.cc',
        'audio_clock.cc',
        'audio_region_editor.cc',
        'audio_region_view.cc',
        'audio_streamview.cc',
        'audio_time_axis.cc',
        'automation_controller.cc',
        'automation_line.cc',
        'automation_region_view.cc',
        'automation_streamview.cc',
        'automation_time_axis.cc',
        'axis_view.cc',
        'big_clock_window.cc',
        'big_transport_window.cc',
        'bundle_manager.cc',
        'clock_group.cc',
        'color_theme_manager.cc',
        'configinfo.cc',
        'control_point.cc',
        'control_point_dialog.cc',
        'control_slave_ui.cc',
        'cursor_context.cc',
        'curvetest.cc',
        'debug.cc',
        'duplicate_routes_dialog.cc',
        'edit_note_dialog.cc',
        'editing.cc',
        'editor.cc',
        'editor_actions.cc',
        'editor_audio_import.cc',
        'editor_pt_import.cc',
        'editor_audiotrack.cc',
        'editor_canvas.cc',
        'editor_canvas_events.cc',
        'editor_component.cc',
        'editor_cursors.cc',
        'editor_drag.cc',
        'editor_route_groups.cc',
        'editor_export_audio.cc',
        'editor_group_tabs.cc',
        'editor_keys.cc',
        'editor_locations.cc',
        'editor_markers.cc',
        'editor_mixer.cc',
        'editor_mouse.cc',
        'editor_ops.cc',
        'editor_regions.cc',
        'editor_routes.cc',
        'editor_rulers.cc',
        'editor_selection.cc',
        'editor_snapshots.cc',
        'editor_sources.cc',
        'editor_summary.cc',
        'editor_tempodisplay.cc',
        'editor_timefx.cc',
        'engine_dialog.cc',
        'enums.cc',
        'export_channel_selector.cc',
        'export_dialog.cc',
        'export_file_notebook.cc',
        'export_filename_selector.cc',
        'export_format_dialog.cc',
        'export_format_selector.cc',
        'export_preset_selector.cc',
        'export_report.cc',
        'export_timespan_selector.cc',
        'fft.cc',
        'fft_graph.cc',
        'fft_result.cc',
        'floating_text_entry.cc',
        'foldback_strip.cc',
        'sfdb_freesound_mootcher.cc',
        'gain_meter.cc',
        'generic_pluginui.cc',
        'ghostregion.cc',
        'global_port_matrix.cc',
        'group_tabs.cc',
        'gui_object.cc',
        'idleometer.cc',
        'insert_remove_time_dialog.cc',
        'instrument_selector.cc',
        'interthread_progress_window.cc',
        'io_selector.cc',
        'hit.cc',
        'keyboard.cc',
        'keyeditor.cc',
        'latency_gui.cc',
        'led.cc',
        'level_meter.cc',
        'location_ui.cc',
        'loudness_dialog.cc',
        'lua_script_manager.cc',
        'luadialog.cc',
        'luainstance.cc',
        'luawindow.cc',
        'main.cc',
        'main_clock.cc',
        'marker.cc',
        'midi_automation_line.cc',
        'midi_channel_dialog.cc',
        'midi_channel_selector.cc',
        'midi_cut_buffer.cc',
        'midi_export_dialog.cc',
        'midi_list_editor.cc',
        'midi_region_view.cc',
        'midi_scroomer.cc',
        'midi_selection.cc',
        'midi_streamview.cc',
        'midi_time_axis.cc',
        'midi_tracer.cc',
        'midi_velocity_dialog.cc',
        'mini_timeline.cc',
        'missing_file_dialog.cc',
        'missing_filesource_dialog.cc',
        'missing_plugin_dialog.cc',
        'mixer_group_tabs.cc',
        'mixer_strip.cc',
        'mixer_ui.cc',
        'meterbridge.cc',
        'meter_strip.cc',
        'meter_patterns.cc',
        'monitor_section.cc',
        'monitor_selector.cc',
        'mono_panner.cc',
        'mono_panner_editor.cc',
        'mouse_cursors.cc',
        'nag.cc',
        'new_plugin_preset_dialog.cc',
        'new_user_wizard.cc',
        'normalize_dialog.cc',
        'note.cc',
        'note_base.cc',
        'note_player.cc',
        'note_select_dialog.cc',
        'nsm.cc',
        'nsmclient.cc',
        'option_editor.cc',
        'opts.cc',
        'panner2d.cc',
        'panner_editor.cc',
        'panner_interface.cc',
        'panner_ui.cc',
        'patch_change.cc',
        'patch_change_widget.cc',
        'pianokeyboard.cc',
        'piano_key_bindings.cc',
        'piano_roll_header.cc',
        'pingback.cc',
        'playlist_selector.cc',
        'plugin_display.cc',
        'plugin_eq_gui.cc',
        'plugin_pin_dialog.cc',
        'plugin_presets_ui.cc',
        'plugin_scan_dialog.cc',
        'plugin_setup_dialog.cc',
        'plugin_selector.cc',
        'plugin_ui.cc',
        'plugin_dspload_ui.cc',
        'plugin_dspload_window.cc',
        'port_group.cc',
        'port_insert_ui.cc',
        'port_matrix.cc',
        'port_matrix_body.cc',
        'port_matrix_column_labels.cc',
        'port_matrix_component.cc',
        'port_matrix_grid.cc',
        'port_matrix_labels.cc',
        'port_matrix_row_labels.cc',
        'processor_box.cc',
        'processor_selection.cc',
        'patch_change_dialog.cc',
        'progress_reporter.cc',
        'pt_import_selector.cc',
        'public_editor.cc',
        'quantize_dialog.cc',
        'rc_option_editor.cc',
        'region_editor.cc',
        'region_gain_line.cc',
        'region_layering_order_editor.cc',
        'region_selection.cc',
        'region_view.cc',
        'return_ui.cc',
        'rhythm_ferret.cc',
        'route_group_dialog.cc',
        'route_group_menu.cc',
        'route_params_ui.cc',
        'route_processor_selection.cc',
        'route_time_axis.cc',
        'route_ui.cc',
        'ruler_dialog.cc',
        'save_as_dialog.cc',
        'save_template_dialog.cc',
        'search_path_option.cc',
        'screensaver.cc',
        'script_selector.cc',
        'selection.cc',
        'selection_memento.cc',
        'send_ui.cc',
        'session_archive_dialog.cc',
        'session_dialog.cc',
        'session_import_dialog.cc',
        'session_metadata_dialog.cc',
        'session_option_editor.cc',
        'sfdb_ui.cc',
        'shuttle_control.cc',
        'soundcloud_export_selector.cc',
        'splash.cc',
        'speaker_dialog.cc',
        'startup_fsm.cc',
        'step_editor.cc',
        'step_entry.cc',
        'stereo_panner.cc',
        'stereo_panner_editor.cc',
        'streamview.cc',
        'strip_silence_dialog.cc',
        'stripable_colorpicker.cc',
        'stripable_time_axis.cc',
        'sys_ex.cc',
        'template_dialog.cc',
        'tempo_curve.cc',
        'tempo_dialog.cc',
        'grid_lines.cc',
        'time_axis_view.cc',
        'time_axis_view_item.cc',
        'time_fx_dialog.cc',
        'time_info_box.cc',
        'time_selection.cc',
        'timers.cc',
        'track_selection.cc',
        'track_view_list.cc',
        'transform_dialog.cc',
        'transport_control.cc',
        'transport_control_ui.cc',
        'transport_masters_dialog.cc',
        'transpose_dialog.cc',
        'ui_config.cc',
        'utils.cc',
        'vca_master_strip.cc',
        'verbose_cursor.cc',
        'virtual_keyboard_window.cc',
        'visibility_group.cc',
        'window_manager.cc',
# video-timeline related sources:
        'video_image_frame.cc',
        'add_video_dialog.cc',
        'editor_videotimeline.cc',
        'vca_time_axis.cc',
        'video_timeline.cc',
        'video_monitor.cc',
        'transcode_ffmpeg.cc',
        'transcode_video_dialog.cc',
        'video_server_dialog.cc',
        'utils_videotl.cc',
        'export_video_dialog.cc',
        'export_video_infobox.cc'
]

def enoify (major, minor):
    # Code names based on
    # https://en.wikipedia.org/wiki/Brian_Eno_discography
    #
    # sort Studio albums + Collaborative albums + Compilation albums by Month/Year.
    # (no Singles, no EPs, no Video Albums, no Production)
    if major == 3:
        return "\\n\\\"E-No\\\""
    elif major == 4:
        if minor == 0:
            return "\\n\\\"No Pussyfooting\\\""
        elif minor == 1:
            return "\\n\\\"Here Come the Warm Jets\\\""
        elif minor == 2:
            return "\\n\\\"Taking Tiger Mountain\\\""
        elif minor == 3:
            return "\\n\\\"Lady June's Linguistic Leprosy\\\""
        elif minor == 4:
            return "\\n\\\"Discreet Music\\\""
        elif minor == 5:
            return "\\n\\\"Another Green World\\\""
        elif minor == 6:
            return "\\n\\\"Evening Star\\\""
        elif minor == 7:
            return "\\n\\\"Cluster and Eno\\\""
    elif major == 5:
        if minor == 0:
            return "\\n\\\"Before and After Science\\\""
        elif minor == 1:
            return "\\n\\\"After the Heat\\\""
        elif minor == 2:
            return "\\n\\\"Music for Airports\\\""
        elif minor == 3:
            return "\\n\\\"Music for Films\\\""
        elif minor == 4:
            return "\\n\\\"In a Land of Clear Colours\\\""
        elif minor == 5:
            return "\\n\\\"The Plateaux of Mirror\\\""
        elif minor == 6:
            return "\\n\\\"Possible Musics\\\"" # 1980 Collaborative
        elif minor == 7:
            return "\\n\\\"My Life in the Bush of Ghosts\\\"" # 1981
        elif minor == 8:
            return "\\n\\\"Music for Airplay\\\"" # 1981 Compilation
        elif minor == 9:
            return "\\n\\\"On Land\\\"" # 1982
        elif minor == 10:
            return "\\n\\\"Atmospheres and Soundtracks\\\"" # 1983
        elif minor == 11:
            return "\\n\\\"More Music for Films\\\"" # 1983
        elif minor == 12:
            return "\\n\\\"Working Backwards\\\"" # 1984 Compilation
    elif major == 6:
        if minor == 0:
            return "\\n\\\"The Pearl\\\"" # 1984 Collaborative
        elif minor == 1:
            return "\\n\\\"Begegnungen\\\"" # 1984 Compilation
        elif minor == 2:
            return "\\n\\\"Thursday Afternoon\\\"" # 1985
        elif minor == 3:
            return "\\n\\\"Hybrid\\\"" # 1985 Collaborative
        elif minor == 4 or minor == 5: # (there was on 6.4 release)
            return "\\n\\\"Old Land\\\"" # 1985 Compilation
        elif minor == 6:
            return "\\n\\\"Desert Island Selection\\\"" # 1986 Compilation
    elif major == 7:
        if minor == 0:
            return "\\n\\\"More Blank Than Frank\\\"" # 1986 Compilation
        if minor == 1:
            return "\\n\\\"Music for Films III\\\"" # 1988 Collaborative
        if minor == 2:
            return "\\n\\\"Wrong Way Up\\\"" # 1990 Collaborative
        if minor == 3:
            return "\\n\\\"Nerve Net\\\"" # 1992
        if minor == 4:
            return "\\n\\\"The Shutov Assembly\\\"" # 1992
        if minor == 5:

=== headless/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options, TaskGen
import waflib.Logs as Logs, waflib.Utils as Utils
import os
import shutil
import sys
import re
import time
from waflib.Task import Task

# Mandatory variables
top = '.'
out = 'build'

hardour_sources = [
        'load_session.cc',
        'misc.cc',
]

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('misc')
    conf.load('compiler_cxx')
    autowaf.configure(conf)


def build(bld):

    VERSION = "%s.%s" % (bld.env['MAJOR'], bld.env['MINOR'])
    if bld.is_defined('WINDOWS_VST_SUPPORT') and bld.env['build_target'] != 'mingw':
        return

    # just the normal executable version of the GTK GUI
    obj = bld (features = 'cxx c cxxprogram')
    # this program does not do the whole hidden symbols thing
    obj.cxxflags = [ '-fvisibility=default' ]
    obj.source    = hardour_sources
    obj.target = 'hardour-' + str (bld.env['VERSION'])
    obj.includes = ['.']

    # at this point, "obj" refers to either the normal native executable
    # OR the shared library built for use with wine on linux.

    obj.use      = [ 'libpbd',
                     'libardour',
                     'libardour_cp',
                     'libtemporal',
                     'libmidipp',
                     ]

    obj.defines = [
        'VERSIONSTRING="' + str(bld.env['VERSION']) + '"',
        'DATA_DIR="' + os.path.normpath(bld.env['DATADIR']) + '"',
        'CONFIG_DIR="' + os.path.normpath(bld.env['SYSCONFDIR']) + '"',
        'LOCALEDIR="' + os.path.join(os.path.normpath(bld.env['DATADIR']), 'locale') + '"',
        ]
    obj.install_path = bld.env['LIBDIR']
    obj.uselib       = 'UUID FLAC FONTCONFIG GLIBMM GIOMM GTHREAD OGG CURL DL XML'
    obj.uselib       += ' AUDIOUNITS OSX'
    obj.uselib       += ' FFTW3F LO TAGLIB LILV RUBBERBAND AUBIO LRDF ARCHIVE VAMPSDK VAMPHOSTSDK'

    if bld.is_defined('HAVE_SUIL'):
        obj.uselib += ' SUIL'

    if sys.platform == 'darwin':
        obj.uselib += ' AUDIOUNITS OSX'
        obj.use    += ' libappleutility'
    obj.includes += ['../libs']

    if bld.env['build_target'] == 'mingw':
        if bld.env['DEBUG'] == False:
            obj.linkflags = ['-mwindows']

    if bld.is_defined('NEED_INTL'):
        obj.linkflags = ' -lintl'

=== luasession/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options, TaskGen
import waflib.Logs as Logs, waflib.Utils as Utils
import os
import shutil
import sys
import re
import time
from waflib.Task import Task

top = '.'
out = 'build'

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('misc')
    conf.load('compiler_cxx')
    conf.check_cc(
            header_name='stdio.h readline/readline.h',
            lib='readline',
            uselib_store='READLINE',
            define_name='HAVE_READLINE',
            mandatory=False)
    autowaf.configure(conf)

def build(bld):
    VERSION = "%s.%s" % (bld.env['MAJOR'], bld.env['MINOR'])
    if not bld.is_defined('HAVE_READLINE'):
            return;
    # no wine
    if bld.is_defined('WINDOWS_VST_SUPPORT') and bld.env['build_target'] != 'mingw':
        return

    # commandline luasession wrapper script
    if bld.env['build_target'] != 'mingw':
        obj              = bld(features = 'subst')
        obj.source       = 'ardour-lua.sh.in'
        obj.target       = 'ardour' + str (bld.env['MAJOR']) + '-lua'
        obj.chmod        = Utils.O755
        obj.install_path = bld.env['BINDIR']
        obj.LIBDIR       = os.path.normpath(bld.env['DLLDIR'])
        obj.DATADIR      = os.path.normpath(bld.env['DATADIR'])
        obj.CONFDIR      = os.path.normpath(bld.env['CONFDIR'])

    # commandline luasession
    obj = bld (features = 'cxx c cxxprogram')
    obj.source       = 'luasession.cc'
    obj.target       = 'luasession'
    obj.includes     = ['../libs']
    obj.use          = ['liblua'
                        'libpbd',
                        'libardour',
                        'libardour_cp',
                        'libtemporal',
                        'libmidipp',
                     ]
    obj.defines = [
        'VERSIONSTRING="' + str(bld.env['VERSION']) + '"',
        'DATA_DIR="'   + os.path.normpath(bld.env['DATADIR']) + '"',
        'CONFIG_DIR="' + os.path.normpath(bld.env['SYSCONFDIR']) + '"',
        'LOCALEDIR="'  + os.path.join(os.path.normpath(bld.env['DATADIR']), 'locale') + '"',
        'PACKAGE="'    + "ARDOURUTILS" + '"',
        ]

    obj.uselib       = 'UUID FLAC FONTCONFIG GLIBMM GIOMM GTHREAD OGG CURL DL XML'
    obj.uselib       += ' AUDIOUNITS OSX LO '
    obj.uselib       += ' READLINE '
    obj.uselib       += ' FFTW3F LO TAGLIB LILV RUBBERBAND AUBIO LRDF ARCHIVE VAMPSDK VAMPHOSTSDK'

    if bld.is_defined('HAVE_SUIL'):
        obj.uselib += ' SUIL'

    if sys.platform == 'darwin':
        obj.uselib += ' AUDIOUNITS OSX'
        obj.use    += ' libappleutility'

    #if bld.env['build_target'] == 'mingw':
    #    if bld.env['DEBUG'] == False:
    #        obj.linkflags = ['-mwindows']

    if bld.is_defined('NEED_INTL'):
        obj.linkflags = ' -lintl'

    if bld.env['build_target'] == 'mingw':
        obj.install_path = bld.env['BINDIR']
        obj.target       = 'ardour' + str (bld.env['MAJOR']) + '-lua'
    else:
        obj.install_path = bld.env['DLLDIR']

=== session_utils/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options, TaskGen
import waflib.Logs as Logs, waflib.Utils as Utils
import os
import shutil
import sys
import re
import time
from waflib.Task import Task

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    if not "dummy" in conf.env['BACKENDS']:
        print ('session-utils depend on the dummy backend.')
        autowaf.display_msg(conf, 'build session-utils', 'no')
        return
    # no wine
    if Options.options.windows_vst and Options.options.dist_target != 'mingw':
        autowaf.display_msg(conf, 'build session-utils', 'no')
        return
    autowaf.display_msg(conf, 'build session-utils', 'yes')
    conf.load('misc')
    conf.load('compiler_cxx')
    autowaf.configure(conf)

def build_ardour_util(bld, util):
    pgmprefix = bld.env['PROGRAM_NAME'].lower() + str(bld.env['MAJOR'])

    # just the normal executable version of the GTK GUI
    obj = bld (features = 'cxx c cxxprogram')
    # this program does not do the whole hidden symbols thing
    obj.cxxflags = [ '-fvisibility=default' ]
    obj.source   = ['common.cc', util + '.cc' ]
    obj.target   = pgmprefix + '-' + util
    obj.includes = ['.']
    obj.use      = [ 'libpbd',
                     'libardour',
                     'libardour_cp',
                     'libtemporal',
                     'libmidipp',
                     ]
    obj.defines = [
        'VERSIONSTRING="' + str(bld.env['VERSION']) + '"',
        'UTILNAME="'   + str(pgmprefix + '-' + util) + '"',
        'DATA_DIR="'   + os.path.normpath(bld.env['DATADIR']) + '"',
        'CONFIG_DIR="' + os.path.normpath(bld.env['SYSCONFDIR']) + '"',
        'LOCALEDIR="'  + os.path.join(os.path.normpath(bld.env['DATADIR']), 'locale') + '"',
        'PACKAGE="'    + "ARDOURUTILS" + '"',
        ]
    obj.install_path = bld.env['LIBDIR'] + '/utils'
    obj.uselib       = 'UUID FLAC FONTCONFIG GLIBMM GIOMM GTHREAD OGG CURL DL XML'
    obj.uselib       += ' AUDIOUNITS OSX LO '
    obj.uselib       += ' FFTW3F LO TAGLIB LILV RUBBERBAND AUBIO LRDF ARCHIVE VAMPSDK VAMPHOSTSDK'

    if bld.is_defined('HAVE_SUIL'):
        obj.uselib += ' SUIL'

    if sys.platform == 'darwin':
        obj.uselib += ' AUDIOUNITS OSX'
        obj.use    += ' libappleutility'
    obj.includes += ['../libs']

    if bld.env['build_target'] == 'mingw':
        obj.install_path = bld.env['BINDIR']

    if bld.is_defined('NEED_INTL'):
        obj.linkflags = ' -lintl'


def build(bld):
    VERSION = "%s.%s" % (bld.env['MAJOR'], bld.env['MINOR'])
    # session-utils depend on the dummy backend
    if not "dummy" in bld.env['BACKENDS']:
        return
    # no wine
    if bld.is_defined('WINDOWS_VST_SUPPORT') and bld.env['build_target'] != 'mingw':
        return

    pgmprefix = bld.env['PROGRAM_NAME'].lower() + str(bld.env['MAJOR'])

    utils = bld.path.ant_glob('[a-z]*.cc', excl=['example.cc', 'common.cc'])

    for util in utils:
        fn = os.path.splitext(os.path.basename(str(util)))[0]
        build_ardour_util(bld, fn)
        if bld.env['build_target'] != 'mingw':
            bld.symlink_as(bld.env['BINDIR'] + '/' + pgmprefix + "-" + fn, bld.env['LIBDIR'] + '/utils/ardour-util.sh')

    if bld.env['build_target'] == 'mingw':
        return

    obj              = bld(features = 'subst')
    obj.source       = 'ardour-util.sh.in'
    obj.target       = 'ardour-util.sh'
    obj.chmod        = Utils.O755
    obj.install_path = bld.env['LIBDIR']  + '/utils'
    obj.LIBDIR       = os.path.normpath(bld.env['DLLDIR'])
    obj.DATADIR      = os.path.normpath(bld.env['DATADIR'])
    obj.CONFDIR      = os.path.normpath(bld.env['CONFDIR'])

=== libs/ardour/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options, Task, Tools
import os
import sys
import re
import subprocess
import sys

# default state file version for this build
CURRENT_SESSION_FILE_VERSION = 6000

I18N_PACKAGE = 'ardour'

# Mandatory variables
top = '.'
out = 'build'

path_prefix = 'libs/ardour/'

libardour_sources = [
        'amp.cc',
        'analyser.cc',
        'analysis_graph.cc',
        'async_midi_port.cc',
        'audio_backend.cc',
        'audio_buffer.cc',
        'audio_library.cc',
        'audio_playlist.cc',
        'audio_playlist_importer.cc',
        'audio_playlist_source.cc',
        'audio_port.cc',
        'audio_region_importer.cc',
        'audio_track.cc',
        'audio_track_importer.cc',
        'audioanalyser.cc',
        'audioengine.cc',
        'audiofile_tagger.cc',
        'audiofilesource.cc',
        'audioregion.cc',
        'audiorom.cc',
        'audiosource.cc',
        'auditioner.cc',
        'automatable.cc',
        'automation.cc',
        'automation_control.cc',
        'automation_list.cc',
        'automation_watch.cc',
        'beats_samples_converter.cc',
        'broadcast_info.cc',
        'buffer.cc',
        'buffer_manager.cc',
        'buffer_set.cc',
        'bundle.cc',
        'butler.cc',
        'capturing_processor.cc',
        'chan_count.cc',
        'chan_mapping.cc',
        'config_text.cc',
        'control_group.cc',
        'control_protocol_manager.cc',
        'convolver.cc',
        'cycle_timer.cc',
        'data_type.cc',
        'default_click.cc',
        'debug.cc',
        'delayline.cc',
        'delivery.cc',
        'directory_names.cc',
        'disk_io.cc',
        'disk_reader.cc',
        'disk_writer.cc',
        'dsp_filter.cc',
        'ebur128_analysis.cc',
        'element_import_handler.cc',
        'element_importer.cc',
        'engine_slave.cc',
        'enums.cc',
        'event_type_map.cc',
        'export_channel.cc',
        'export_channel_configuration.cc',
        'export_failed.cc',
        'export_filename.cc',
        'export_format_base.cc',
        'export_format_manager.cc',
        'export_format_specification.cc',
        'export_formats.cc',
        'export_graph_builder.cc',
        'export_handler.cc',
        'export_preset.cc',
        'export_profile_manager.cc',
        'export_status.cc',
        'export_timespan.cc',
        'file_source.cc',
        'filename_extensions.cc',
        'filesystem_paths.cc',
        'filter.cc',
        'find_session.cc',
        'fixed_delay.cc',
        'fluid_synth.cc',
        'gain_control.cc',
        'globals.cc',
        'graph.cc',
        'graphnode.cc',
        'iec1ppmdsp.cc',
        'iec2ppmdsp.cc',
        'import.cc',
        'import_pt.cc',
        'instrument_info.cc',
        'internal_return.cc',
        'internal_send.cc',
        'interpolation.cc',
        'io.cc',
        'io_processor.cc',
        'kmeterdsp.cc',
        'ladspa_plugin.cc',
        'latent.cc',
        'legatize.cc',
        'location.cc',
        'location_importer.cc',
        'ltc_file_reader.cc',
        'ltc_slave.cc',
        'lua_api.cc',
        'luabindings.cc',
        'luaproc.cc',
        'luascripting.cc',
        'meter.cc',
        'midi_automation_list_binder.cc',
        'midi_buffer.cc',
        'midi_channel_filter.cc',
        'midi_clock_slave.cc',
        'midi_model.cc',
        'midi_patch_manager.cc',
        'midi_playlist.cc',
        'midi_playlist_source.cc',
        'midi_port.cc',
        'midi_region.cc',
        'midi_ring_buffer.cc',
        'midi_scene_change.cc',
        'midi_scene_changer.cc',
        'midi_source.cc',
        'midi_state_tracker.cc',
        'midi_stretch.cc',
        'midi_track.cc',
        'midi_ui.cc',
        'mididm.cc',
        'midiport_manager.cc',
        'mix.cc',
        'mode.cc',
        'monitor_control.cc',
        'monitor_processor.cc',
        'mp3fileimportable.cc',
        'mp3filesource.cc',
        'mtc_slave.cc',
        'mtdm.cc',
        'muteable.cc',
        'mute_control.cc',
        'mute_master.cc',
        'onset_detector.cc',
        'operations.cc',
        'pan_controllable.cc',
        'pannable.cc',
        'panner.cc',
        'panner_manager.cc',
        'panner_shell.cc',
        'parameter_descriptor.cc',
        'phase_control.cc',
        'playlist.cc',
        'playlist_factory.cc',
        'playlist_source.cc',
        'plugin.cc',
        'plugin_insert.cc',
        'plugin_manager.cc',
        'polarity_processor.cc',
        'port.cc',
        'port_engine_shared.cc',
        'port_insert.cc',
        'port_manager.cc',
        'port_set.cc',
        'presentation_info.cc',
        'process_thread.cc',
        'processor.cc',
        'progress.cc',
        'quantize.cc',
        'rc_configuration.cc',
        'readable.cc',
        'readonly_control.cc',
        'raw_midi_parser.cc',
        'recent_sessions.cc',
        'record_enable_control.cc',
        'record_safe_control.cc',
        'region_factory.cc',
        'resampled_source.cc',
        'region.cc',
        'return.cc',
        'reverse.cc',
        'route.cc',
        'route_graph.cc',
        'route_group.cc',
        'route_group_member.cc',
        'rb_effect.cc',
        'rt_tasklist.cc',
        'scene_change.cc',
        'search_paths.cc',
        'selection.cc',
        'send.cc',
        'session.cc',
        'session_bundles.cc',
        'session_butler.cc',
        'session_click.cc',
        'session_command.cc',
        'session_configuration.cc',
        'session_directory.cc',
        'session_events.cc',
        'session_export.cc',
        'session_handle.cc',
        'session_ltc.cc',
        'session_metadata.cc',
        'session_midi.cc',
        'session_object.cc',
        'session_playlists.cc',
        'session_process.cc',
        'session_rtevents.cc',
        'session_state.cc',
        'session_state_utils.cc',
        'session_time.cc',
        'session_transport.cc',
        'sidechain.cc',
        'slavable.cc',
        'slavable_automation_control.cc',
        'smf_source.cc',
        'sndfile_helpers.cc',
        'sndfileimportable.cc',
        'sndfilesource.cc',
        'solo_control.cc',
        'solo_isolate_control.cc',
        'solo_safe_control.cc',
        'soundcloud_upload.cc',
        'source.cc',
        'source_factory.cc',
        'speakers.cc',
        'srcfilesource.cc',
        'stripable.cc',
        'strip_silence.cc',
        'system_exec.cc',
        'revision.cc',
        'rt_midibuffer.cc',
        'template_utils.cc',
        'tempo.cc',
        'tempo_map_importer.cc',
        'thread_buffers.cc',
        'ticker.cc',
        'track.cc',
        'transient_detector.cc',
        'transform.cc',
        'transport_fsm.cc',
        'transport_master.cc',
        'transport_master_manager.cc',
        'transpose.cc',
        'unknown_processor.cc',
        'user_bundle.cc',
        'utils.cc',
        'vca.cc',
        'vca_manager.cc',
        'video_tools_paths.cc',
        'vumeterdsp.cc',
        'worker.cc'
]

def flac_supported():
    cmd = subprocess.Popen ("sndfile-info testfile.flac",
                            stdout = subprocess.PIPE,
                            stderr = subprocess.STDOUT, shell = True)
    out = cmd.communicate()[0].decode('utf-8');
    return re.search ('unknown format', out) == None

def ogg_supported():
    cmd = subprocess.Popen ("sndfile-info testfile.ogg",
                            stdout = subprocess.PIPE,
                            stderr = subprocess.STDOUT, shell = True)
    out = cmd.communicate()[0].decode('utf-8');
    return re.search ('unknown format', out) == None

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('compiler_cxx')
    conf.load('gas')
    # we don't use hard-coded micro versions with ardour, so hard code it to zero
    autowaf.configure(conf)
    autowaf.check_pkg(conf, 'aubio', uselib_store='AUBIO',
                      atleast_version='0.3.2')
    autowaf.check_pkg(conf, 'aubio', uselib_store='AUBIO4',
                      atleast_version='0.4.0', mandatory=False)
    autowaf.check_pkg(conf, 'libxml-2.0', uselib_store='XML')
    if Options.options.dist_target != 'mingw':
        if not Options.options.no_lrdf:
            autowaf.check_pkg(conf, 'lrdf', uselib_store='LRDF',
                              atleast_version='0.4.0')
        autowaf.check_pkg(conf, 'aubio', uselib_store='AUBIO',
                          atleast_version='0.3.2')
    autowaf.check_pkg(conf, 'samplerate', uselib_store='SAMPLERATE',
                      atleast_version='0.1.0')
    autowaf.check_pkg(conf, 'sigc++-2.0', uselib_store='SIGCPP',
                      atleast_version='2.0')

    autowaf.check_pkg(conf, 'lv2', uselib_store='LV2',
                      atleast_version='1.2.0', mandatory=True)
    autowaf.check_pkg(conf, 'lv2', uselib_store='LV2_1_10_0',
                      atleast_version='1.10.0', mandatory=False)
    autowaf.check_pkg(conf, 'lv2', uselib_store='LV2_1_17_2',
                      atleast_version='1.17.2', mandatory=False)
    autowaf.check_pkg(conf, 'serd-0', uselib_store='SERD',
                      atleast_version='0.14.0', mandatory=True)
    autowaf.check_pkg(conf, 'sord-0', uselib_store='SORD',
                      atleast_version='0.8.0', mandatory=True)
    autowaf.check_pkg(conf, 'sratom-0', uselib_store='SRATOM',
                      atleast_version='0.2.0', mandatory=True)
    autowaf.check_pkg(conf, 'lilv-0', uselib_store='LILV',
                      atleast_version='0.24.2', mandatory=True)
    autowaf.check_pkg(conf, 'suil-0', uselib_store='SUIL',
                      atleast_version='0.6.0', mandatory=False)
    conf.define ('LV2_SUPPORT', 1)

    # non-standard LV2 extention -- TODO: add option to disable??
    if conf.is_defined ('HAVE_LV2_1_10_0'):
        conf.define ('LV2_EXTENDED', 1)

    autowaf.check_pkg(conf, 'soundtouch', uselib_store='SOUNDTOUCH',
                      atleast_version='1.8.0', mandatory=False)
    autowaf.check_pkg(conf, 'cppunit', uselib_store='CPPUNIT',
                      atleast_version='1.12.0', mandatory=False)
    autowaf.check_pkg(conf, 'ogg', uselib_store='OGG', atleast_version='1.1.2')
    autowaf.check_pkg(conf, 'flac', uselib_store='FLAC',
                      atleast_version='1.2.1')
    autowaf.check_pkg(conf, 'libcurl', uselib_store='CURL',
                      atleast_version='7.0.0')

    autowaf.check_pkg(conf, 'fftw3f', uselib_store='FFTW35F',
                      atleast_version='3.3.5', mandatory=False)

    # controls whether we actually use it in preference to soundtouch
    # Note: as of 2104, soundtouch (WSOLA) has been out-of-use for years.
    conf.define('USE_RUBBERBAND', 1)

    conf.define('CURRENT_SESSION_FILE_VERSION', CURRENT_SESSION_FILE_VERSION)

    conf.check(header_name='sys/vfs.h', define_name='HAVE_SYS_VFS_H',mandatory=False)
    conf.check(header_name='sys/statvfs.h', define_name='HAVE_SYS_STATVFS_H',mandatory=False)

    conf.check(header_name='unistd.h', define_name='HAVE_UNISTD',mandatory=False)

    if flac_supported():
        conf.define ('HAVE_FLAC', 1)
    if ogg_supported():
        conf.define ('HAVE_OGG', 1)

    conf.write_config_header('libardour-config.h', remove=False)

    # Boost headers
    autowaf.check_header(conf, 'cxx', 'boost/shared_ptr.hpp')
    autowaf.check_header(conf, 'cxx', 'boost/weak_ptr.hpp')
    autowaf.check_header(conf, 'cxx', 'boost/scoped_ptr.hpp')
    autowaf.check_header(conf, 'cxx', 'boost/ptr_container/ptr_list.hpp')
    if conf.env['WINDOWS_VST_SUPPORT'] == True and Options.options.dist_target == 'mingw':
        conf.check(compiler='cxx',
                   lib='gdi32',
                   mandatory=True,
                   uselib_store='GDI32')


def build(bld):
    # Library version (UNIX style major, minor, micro)

=== libs/audiographer/wscript ===
#!/usr/bin/env python
# -*- coding: utf-8 -*-
from waflib.extras import autowaf as autowaf
import os

# Version of this package (even if built as a child)
AUDIOGRAPHER_VERSION = '0.0.0'

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
# Version history:
#   0.0.0 = 0,0,0
AUDIOGRAPHER_LIB_VERSION = '0.0.0'

# Variables for 'waf dist'
APPNAME = 'audiographer'
VERSION = AUDIOGRAPHER_VERSION

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('compiler_cxx')
    autowaf.configure(conf)

    autowaf.check_pkg(conf, 'cppunit', uselib_store='CPPUNIT', atleast_version='1.12.0', mandatory=False)
    autowaf.check_pkg(conf, 'sigc++-2.0', uselib_store='SIGCPP', atleast_version='2.0', mandatory=False)
    autowaf.check_pkg(conf, 'glib-2.0', uselib_store='GLIB', atleast_version='2.2', mandatory=False)
    autowaf.check_pkg(conf, 'glibmm-2.4', uselib_store='GLIBMM', atleast_version='2.14.0', mandatory=False)
    autowaf.check_pkg(conf, 'gthread-2.0', uselib_store='GTHREAD', atleast_version='2.14.0', mandatory=False)
    autowaf.check_pkg(conf, 'samplerate', uselib_store='SAMPLERATE', atleast_version='0.1.7', mandatory=False)
    autowaf.check_pkg(conf, 'sndfile', uselib_store='SNDFILE', atleast_version='1.0.18', mandatory=False)
    autowaf.check_pkg(conf, 'fftw3f', uselib_store='FFTW3F', mandatory=True)

    # Boost headers
    autowaf.check_header(conf, 'cxx', 'boost/shared_ptr.hpp')
    autowaf.check_header(conf, 'cxx', 'boost/format.hpp')

def build(bld):

    # Headers
    #bld.install_files('${INCLUDEDIR}/audiographer', bld.path.ant_glob('audiographer/*.h'))
    #bld.install_files('${INCLUDEDIR}/audiographer/general', bld.path.ant_glob('audiographer/general/*.h'))
    #bld.install_files('${INCLUDEDIR}/audiographer/sndfile', bld.path.ant_glob('audiographer/sndfile/*.h'))
    #bld.install_files('${INCLUDEDIR}/audiographer/utils', bld.path.ant_glob('audiographer/utils/*.h'))

    #bld.env['BUILD_TESTS'] = True
    bld.env['HAVE_ALL_GTHREAD'] = (bld.is_defined('HAVE_GLIB')
                                   and bld.is_defined('HAVE_GLIBMM')
                                   and bld.is_defined('HAVE_GTHREAD'))

    if bld.is_defined('HAVE_FFTW35F') and bld.env['build_target'] != 'mingw':
        bld.env['LIB_FFTW3F'] += ['fftw3f_threads']

    audiographer_sources = [
        'private/gdither/gdither.cc',
        'src/general/sample_format_converter.cc',
        'src/routines.cc',
        'src/debug_utils.cc',
        'src/general/analyser.cc',
        'src/general/broadcast_info.cc',
        'src/general/demo_noise.cc',
        'src/general/loudness_reader.cc',
        'src/general/normalizer.cc'
        ]
    if bld.is_defined('HAVE_SAMPLERATE'):
        audiographer_sources += [ 'src/general/sr_converter.cc' ]

    if bld.is_defined ('INTERNAL_SHARED_LIBS'):
        audiographer              = bld.shlib(features = 'c cxx cshlib cxxshlib', source=audiographer_sources)
        # macros for this shared library
        audiographer.defines      = [ 'LIBAUDIOGRAPHER_DLL_EXPORTS=1' ]
    else:
        audiographer              = bld.stlib(features = 'c cxx cstlib cxxstlib', source=audiographer_sources)
        audiographer.cxxflags     = [ bld.env['compiler_flags_dict']['pic'] ]
        audiographer.cflags       = [ bld.env['compiler_flags_dict']['pic'] ]
        audiographer.defines      = []

    audiographer.name           = 'libaudiographer'
    audiographer.target         = 'audiographer'
    audiographer.export_includes = ['.', './src']
    audiographer.includes       = ['.', './src','../ardour','../temporal','../evoral']
    audiographer.uselib         = 'GLIB GLIBMM GTHREAD SAMPLERATE SNDFILE FFTW3F VAMPSDK VAMPHOSTSDK XML'
    audiographer.use            = 'libpbd'
    audiographer.vnum           = AUDIOGRAPHER_LIB_VERSION
    audiographer.install_path   = bld.env['LIBDIR']


    if bld.env['BUILD_TESTS'] and bld.is_defined('HAVE_CPPUNIT'):
        # Unit tests
        obj              = bld(features = 'cxx cxxprogram')
        obj.source       = '''
                tests/test_runner.cc
                tests/type_utils_test.cc
                tests/utils/identity_vertex_test.cc
                tests/general/interleaver_test.cc
                tests/general/deinterleaver_test.cc
                tests/general/interleaver_deinterleaver_test.cc
                tests/general/chunker_test.cc
                tests/general/sample_format_converter_test.cc
                tests/general/peak_reader_test.cc
                tests/general/normalizer_test.cc
                tests/general/silence_trimmer_test.cc
        '''

        if bld.is_defined('HAVE_ALL_GTHREAD'):
            obj.source += '''
                    tests/general/threader_test.cc
            '''

        if bld.is_defined('HAVE_SNDFILE'):
            obj.source += '''
                    tests/sndfile/tmp_file_test.cc
            '''

        if bld.is_defined('HAVE_SAMPLERATE'):
            obj.source += '''
                    tests/general/sr_converter_test.cc
            '''

        obj.use          = 'libaudiographer'
        obj.uselib       = 'CPPUNIT GLIBMM SAMPLERATE SNDFILE FFTW3F VAMPSDK VAMPHOSTSDK'
        obj.target       = 'run-tests'
        obj.name         = 'audiographer-unit-tests'
        obj.install_path = ''

def shutdown():
    autowaf.shutdown()

=== libs/canvas/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options
from waflib import TaskGen
import os

# Version of this package (even if built as a child)
MAJOR = '0'
MINOR = '0'
MICRO = '0'
CANVAS_VERSION = "%s.%s.%s" % (MAJOR, MINOR, MICRO)

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
CANVAS_LIB_VERSION = '0.0.0'

# Variables for 'waf dist'
APPNAME = 'canvas'
VERSION = CANVAS_VERSION
I18N_PACKAGE = 'libcanvas'

# Mandatory variables
top = '.'
out = 'build'

path_prefix = 'libs/canvas/'

canvas_sources = [
        'arc.cc',
        'arrow.cc',
        'box.cc',
        'canvas.cc',
        'circle.cc',
        'container.cc',
        'curve.cc',
        'debug.cc',
        'item.cc',
        'fill.cc',
        'flag.cc',
        'framed_curve.cc',
        'grid.cc',
        'image.cc',
        'line.cc',
        'line_set.cc',
        'lookup_table.cc',
        'meter.cc',
        'note.cc',
        'outline.cc',
        'pixbuf.cc',
        'poly_item.cc',
        'poly_line.cc',
        'polygon.cc',
        'rectangle.cc',
        'root_group.cc',
        'ruler.cc',
        'scroll_group.cc',
        'stateful_image.cc',
        'text.cc',
        'tracking_text.cc',
        'types.cc',
        'utils.cc',
        'widget.cc',
        'xfade_curve.cc',
]

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load ('compiler_cxx')
    autowaf.configure(conf)
    autowaf.check_pkg(conf, 'cairomm-1.0', uselib_store='CAIROMM', atleast_version='1.8.4')

def build(bld):
    # Library
    if bld.is_defined ('INTERNAL_SHARED_LIBS'):
        obj = bld.shlib(features = 'cxx cxxshlib', source=canvas_sources)
        obj.defines      = [ 'LIBCANVAS_DLL_EXPORTS=1' ]
    else:
        obj = bld.stlib(features = 'cxx cxxstlib', source=canvas_sources)
        obj.cxxflags = [ bld.env['compiler_flags_dict']['pic'] ]
        obj.cflags   = [ bld.env['compiler_flags_dict']['pic'] ]
        obj.defines  = [ ]

    obj.export_includes = ['.']
    obj.includes     = ['.']
    obj.uselib       = 'SIGCPP CAIROMM GTKMM BOOST XML OSX'
    obj.use          = [ 'libpbd', 'libgtkmm2ext' ]
    obj.name         = 'libcanvas'
    obj.target       = 'canvas'
    obj.vnum         = CANVAS_LIB_VERSION
    obj.install_path = bld.env['LIBDIR']
    obj.defines      += [ 'PACKAGE="' + I18N_PACKAGE + '"' ]

    # canvas unit-tests are outdated
    if False and bld.env['BUILD_TESTS'] and bld.is_defined('HAVE_CPPUNIT'):
            unit_testobj              = bld(features = 'cxx cxxprogram')
            unit_testobj.source       = '''
                    test/group.cc
                    test/arrow.cc
                    test/optimizing_lookup_table.cc
                    test/polygon.cc
                    test/types.cc
                    test/render.cc
                    test/xml.cc
                    test/wave_view.cc
                    test/item.cc
                    test/testrunner.cpp
                '''.split()

            unit_testobj.includes     = obj.includes + ['test', '../pbd']
            unit_testobj.uselib       = 'CPPUNIT SIGCPP CAIROMM GTKMM'
            unit_testobj.uselib_local = 'libcanvas libgtkmm2ext'
            unit_testobj.name         = 'libcanvas-unit-tests'
            unit_testobj.target       = 'run-tests'
            unit_testobj.install_path = ''
            unit_testobj.cxxflags     = ['-DPACKAGE="libcanvastest"']
            unit_testobj.cxxflags     += ['-DDATA_DIR="' + os.path.normpath(bld.env['DATADIR']) + '"']
            unit_testobj.cxxflags     += ['-DCONFIG_DIR="' + os.path.normpath(bld.env['CONFDIR']) + '"']
            unit_testobj.cxxflags     += ['-DMODULE_DIR="' + os.path.normpath(bld.env['LIBDIR']) + '"']

            manual_tests              = '''
                        test/hello_world.cc
                        test/gtk_many.cc
                        test/gtk_scene.cc
                        test/gtk_movement.cc
                        test/gtk_viewport.cc
                        test/gtk_drag.cc
                '''.split()

            for t in manual_tests:
                    target = t[:-3]
                    name = t[t.find('/')+1:-3]
                    manual_testobj = bld(features = 'cxx cxxprogram')
                    manual_testobj.source = t
                    manual_testobj.includes = obj.includes + ['test', '../pbd']
                    manual_testobj.uselib       = 'CPPUNIT SIGCPP CAIROMM GTKMM'
                    manual_testobj.uselib_local = 'libcanvas libgtkmm2ext'
                    manual_testobj.name         = 'libcanvas-manual-test-%s' % name
                    manual_testobj.target       = target
                    manual_testobj.install_path = ''

            benchmarks = '''
                        benchmark/items_at_point.cc
                        benchmark/render_parts.cc
                        benchmark/render_from_log.cc
                        benchmark/render_whole.cc
                '''.split()

            for t in benchmarks:
                    target = t[:-3]
                    name = t[t.find('/')+1:-3]
                    manual_testobj = bld(features = 'cxx cxxprogram')
                    manual_testobj.source = [ t, 'benchmark/benchmark.cc' ]
                    manual_testobj.includes = obj.includes + ['test', '../pbd']
                    manual_testobj.uselib       = 'CPPUNIT SIGCPP CAIROMM GTKMM'
                    manual_testobj.uselib_local = 'libcanvas libgtkmm2ext'
                    manual_testobj.name         = 'libcanvas-benchmark-%s' % name
                    manual_testobj.target       = target
                    manual_testobj.install_path = ''

def shutdown():
    autowaf.shutdown()

=== libs/evoral/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options
import os

# Version of this package (even if built as a child)
EVORAL_VERSION = '0.0.0'

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
# Version history:
#   0.0.0 = 0,0,0
EVORAL_LIB_VERSION = '0.0.0'

# Variables for 'waf dist'
APPNAME = 'evoral'
VERSION = EVORAL_VERSION

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    opt.load('compiler_c')
    opt.load('compiler_cxx')
    autowaf.set_options(opt)
    opt.add_option('--test', action='store_true', default=False, dest='build_tests',
                    help="Build unit tests")
    opt.add_option('--test-coverage', action='store_true', default=False, dest='test_coverage',
                    help="Use gcov to test for code coverage")
    opt.add_option('--internal-shared-libs', action='store_true', default=True, dest='internal_shared_libs',
                   help='Build internal libs as shared libraries')

def configure(conf):
    conf.load('compiler_c')
    conf.load('compiler_cxx')
    autowaf.configure(conf)
    #autowaf.display_header('Evoral Configuration')

    autowaf.check_pkg(conf, 'cppunit', uselib_store='CPPUNIT', atleast_version='1.12.0', mandatory=False)
    autowaf.check_pkg(conf, 'glib-2.0', uselib_store='GLIB', atleast_version='2.2')
    autowaf.check_pkg(conf, 'glibmm-2.4', uselib_store='GLIBMM', atleast_version='2.14.0')
    autowaf.check_pkg(conf, 'gthread-2.0', uselib_store='GTHREAD', atleast_version='2.14.0')
    if not autowaf.is_child():
        autowaf.check_pkg(conf, 'libpbd-4', uselib_store='LIBPBD', atleast_version='4.0.0', mandatory=True)

    # Boost headers
    autowaf.check_header(conf, 'cxx', 'boost/shared_ptr.hpp')
    autowaf.check_header(conf, 'cxx', 'boost/weak_ptr.hpp')

    conf.env['BUILD_TESTS'] = Options.options.build_tests
    conf.env['TEST_COVERAGE'] = Options.options.test_coverage

    if Options.options.internal_shared_libs:
        conf.define('INTERNAL_SHARED_LIBS', 1)
    #autowaf.display_msg(conf, "Unit tests", str(conf.env['BUILD_TESTS']))
    #print

def build(bld):
    # Headers
    #bld.install_files('${INCLUDEDIR}/evoral', 'evoral/*.h')
    #bld.install_files('${INCLUDEDIR}/evoral', 'evoral/*.h')

    # Pkgconfig file
    #autowaf.build_pc(bld, 'EVORAL', EVORAL_VERSION, 'GLIBMM GTHREAD')

    libsmf = bld(features = 'c cstlib')
    libsmf.source = '''
            libsmf/smf.c
            libsmf/smf_decode.c
            libsmf/smf_load.c
            libsmf/smf_save.c
            libsmf/smf_tempo.c
    '''
    libsmf.export_includes = ['./libsmf']
    libsmf.defines      = ['SMF_VERSION="1.2"', 'LIBSMF_DLL_EXPORTS']
    libsmf.includes     = ['./src']
    libsmf.name         = 'libsmf'
    libsmf.target       = 'smf'
    libsmf.uselib       = 'GLIB'
    libsmf.use          = [ 'libtemporal' ]
    libsmf.install_path = None
    if bld.env['build_target'] != 'mingw':
        libsmf.cxxflags     = [ bld.env['compiler_flags_dict']['pic'] ]
        libsmf.cflags       = [ bld.env['compiler_flags_dict']['pic'] ]

    lib_source = '''
            Control.cc
            ControlList.cc
            ControlSet.cc
            Curve.cc
            Event.cc
            Note.cc
            SMF.cc
            Sequence.cc
            TimeConverter.cc
            debug.cc
    '''

    # Library
    if bld.is_defined ('INTERNAL_SHARED_LIBS'):
        obj              = bld.shlib(features = 'c cxx cshlib cxxshlib', source=lib_source)
        # DLL exports for this library
        obj.defines      = [ 'LIBEVORAL_DLL_EXPORTS' ]
    else:
        obj              = bld.stlib(features = 'c cxx cstlib cxxstlib', source=lib_source)
        obj.cxxflags     = [ bld.env['compiler_flags_dict']['pic'] ]
        obj.cflags       = [ bld.env['compiler_flags_dict']['pic'] ]
        obj.defines      = [ ]

    obj.export_includes = ['.']
    obj.includes       = ['.', './src']
    obj.name           = 'libevoral'
    obj.target         = 'evoral'
    obj.uselib         = 'GLIBMM GTHREAD SMF XML LIBPBD OSX'
    obj.use            = 'libsmf libpbd'
    obj.vnum           = EVORAL_LIB_VERSION
    obj.install_path   = bld.env['LIBDIR']
    obj.defines       += [ 'PACKAGE="libevoral"' ]

    if bld.env['BUILD_TESTS'] and bld.is_defined('HAVE_CPPUNIT'):
        # Static library (for unit test code coverage)
        obj = bld(features = 'cxx cstlib')
        obj.source         = lib_source
        obj.export_includes = ['.']
        obj.includes       = ['.', './src']
        obj.name           = 'libevoral_static'
        obj.target         = 'evoral_static'
        obj.uselib         = 'GLIBMM GTHREAD SMF XML LIBPBD'
        obj.use            = 'libsmf libpbd'
        obj.vnum           = EVORAL_LIB_VERSION
        obj.install_path   = ''
        if bld.env['TEST_COVERAGE']:
            obj.linkflags      = ['--coverage']
            obj.cflags         = ['--coverage']
            obj.cxxflags       = ['--coverage']
        obj.defines        = ['PACKAGE="libevoral"']

        # Unit tests
        obj              = bld(features = 'cxx cxxprogram')
        obj.source       = '''
                test/SequenceTest.cc
                test/SMFTest.cc
                test/RangeTest.cc
                test/NoteTest.cc
                test/CurveTest.cc
                test/testrunner.cc
        '''
        obj.includes     = ['.', './src']
        obj.use          = 'libevoral_static'
        obj.uselib       = 'GLIBMM GTHREAD SMF XML LIBPBD OSX CPPUNIT'
        obj.target       = 'run-tests'
        obj.name         = 'libevoral-tests'
        obj.install_path = ''
        obj.defines      = ['PACKAGE="libevoraltest"']
        if bld.env['TEST_COVERAGE']:
            obj.linkflags      = ['--coverage']
            obj.cflags         = ['--coverage']
            obj.cxxflags       = ['--coverage']

def test(ctx):
    autowaf.pre_test(ctx, APPNAME)
    print(os.getcwd())
    os.environ['EVORAL_TEST_PATH'] = os.path.abspath('../test/testdata/')
    autowaf.run_tests(ctx, APPNAME, ['./run-tests'])
    autowaf.post_test(ctx, APPNAME)

=== libs/fluidsynth/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import TaskGen
import os
import sys

# Version of this package (even if built as a child)
MAJOR = '2'
MINOR = '0'
MICRO = '1'
LIBFLUIDSYNTH_VERSION = "%s.%s.%s" % (MAJOR, MINOR, MICRO)

# Variables for 'waf dist'
APPNAME = 'libltc'
VERSION = LIBFLUIDSYNTH_VERSION
I18N_PACKAGE = 'libfluidsynth'

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    if conf.is_defined('USE_EXTERNAL_LIBS'):
        autowaf.check_pkg(conf, 'fluidsynth', uselib_store='LIBFLUIDSYNTH', atleast_version=LIBFLUIDSYNTH_VERSION, mandatory=True)
    else:
        conf.load('compiler_c')
        autowaf.configure(conf)

def build(bld):
    if bld.is_defined('USE_EXTERNAL_LIBS'):
        return
    bld (export_includes = ['fluidsynth'],
         name = 'libfluidsynth_includes'
         )
    obj = bld.stlib (source = [
        'src/fluid_midi.c',
        'src/fluid_adsr_env.c',
        'src/fluid_chorus.c',
        'src/fluid_iir_filter.c',
        'src/fluid_lfo.c',
        'src/fluid_rev.c',
        'src/fluid_rvoice.c',
        'src/fluid_rvoice_dsp.c',
        'src/fluid_rvoice_event.c',
        'src/fluid_rvoice_mixer.c',
        'src/fluid_defsfont.c',
        'src/fluid_chan.c',
        'src/fluid_event.c',
        'src/fluid_gen.c',
        'src/fluid_mod.c',
        'src/fluid_synth.c',
        'src/fluid_tuning.c',
        'src/fluid_voice.c',
        'src/fluid_conv.c',
        'src/fluid_hash.c',
        'src/fluid_list.c',
        'src/fluid_ringbuffer.c',
        'src/fluid_samplecache.c',
        'src/fluid_settings.c',
        'src/fluid_sffile.c',
        'src/fluid_sfont.c',
        'src/fluid_synth_monopoly.c',
        'src/fluid_sys.c'
        ],
        cflags = [ bld.env['compiler_flags_dict']['pic'], '-fvisibility=hidden', '-std=gnu99', '-Wno-unused-function' ],
        includes = ['.', 'src/' ],
               target = 'libfluidsynth',
               use    = 'libfluidsynth_includes',
               uselib = 'GLIB',
               defines = [ 'HAVE_CONFIG_H', 'DEFAULT_SOUNDFONT=""' ]
               )

    # wine-gcc hacks:
    # defining __MINGW32__ for wine-gcc is a workaround for fluidsynth's include
    # strategy (which is made for mingw or windows) without it
    # winsock2.h will complain about undeclared "u_short"
    # we also need to explicitly define  _WIN32
    if bld.is_defined('WINDOWS_VST_SUPPORT') and not bld.env['build_target'] == 'mingw':
        obj.defines += [ '_WIN32', '__MINGW32__' ]

def shutdown():
    autowaf.shutdown()

=== libs/fst/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options, TaskGen
import waflib.Logs as Logs, waflib.Utils as Utils
import os
import shutil
import sys
import re
import time
from waflib.Task import Task

# Mandatory variables
top = '.'
out = 'build'

# needed for code used from libardour
I18N_PACKAGE = 'ardour'

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('misc')
    conf.load('compiler_cxx')
    autowaf.configure(conf)
    if conf.env['WINDOWS_VST_SUPPORT'] == True and Options.options.dist_target == 'mingw':
        conf.check(compiler='cxx',
                   lib='gdi32',
                   mandatory=True,
                   uselib_store='GDI32')

# Add a waf `feature' to allow compilation of things using winegcc
from waflib.TaskGen import feature
@feature("wine")
def set_winegcc(self):
    self.env.LINK_CXX = self.env.LINK_CC = 'wineg++'
    self.env.CC = 'winegcc'

def build(bld):
    VERSION = "%s.%s" % (bld.env['MAJOR'], bld.env['MINOR'])

    if bld.is_defined('VST3_SUPPORT'):
        obj = bld (features = 'cxx c cxxprogram')
        obj.source    = 'vst3-scanner.cc'
        obj.target    = 'ardour-vst3-scanner'
        obj.includes  = [ '../pbd/', '../ardour/', '../vst3/', '..' ]
        obj.defines   = [
            'VST3_SCANNER_APP',
            'VERSIONSTRING="' + str(bld.env['VERSION']) + '"',
            'PACKAGE="' + I18N_PACKAGE + str(bld.env['MAJOR']) + '"',
            'LIBARDOUR="' + bld.env['lwrcase_dirname'] + '"',
            'LOCALEDIR="' + os.path.join(os.path.normpath(bld.env['DATADIR']), 'locale') + '"',
            ]
        obj.use = [ 'libpbd' ]
        obj.uselib = 'GIOMM DL UUID ARCHIVE CURL XML'

        if sys.platform == 'darwin':
            obj.uselib += ' OSX'
        if bld.env['build_target'] == 'mingw':
            obj.uselib += ' GDI32'
            obj.linkflags = ['-mwindows']

        if re.search ("bsd", sys.platform) != None:
            obj.defines.append('_POSIX_C_SOURCE=200809')
            obj.defines.append('_XOPEN_SOURCE=700')

        obj.install_path = os.path.join(bld.env['LIBDIR'])

    if not (bld.is_defined('WINDOWS_VST_SUPPORT') or bld.is_defined('LXVST_SUPPORT') or bld.is_defined ('MACVST_SUPPORT')):
        return

    if bld.is_defined('WINDOWS_VST_SUPPORT') and bld.env['build_target'] != 'mingw':
        # wine exec wrapper script
        obj = bld(features = 'subst')
        obj.source = 'scanner.wine'
        obj.target = 'ardour-vst-scanner'
        obj.chmod  = Utils.O755
        obj.install_path = os.path.join(bld.env['LIBDIR'])
        obj.VERSION = bld.env['VERSION']

        obj = bld (features = 'c cxx cxxprogram wine')
        obj.source = (
            'scanner.cc',
            'vstwin.c',
            )
        obj.linkflags = ['-mwindows', '-Wl,--export-dynamic']
        obj.linkflags += bld.env['LDFLAGS']
        obj.target = 'ardour-vst-scanner.exe.so'
        obj.uselib = ['GIOMM', 'DL']
        obj.use = [ 'libpbd' ]
        obj.cxxflags = [  bld.env['compiler_flags_dict']['pic'] ]
    else:
        obj = bld (features = 'cxx c cxxprogram')
        obj.source = ( 'scanner.cc' )
        obj.target = 'ardour-vst-scanner'
        if bld.is_defined('WINDOWS_VST_SUPPORT'):
            bld (features = 'c', name='vstwin', source='vstwin.c', uselib = 'GIOMM', includes  = [ '../pbd/', '../ardour/', '.' ])
            obj.uselib = ['GIOMM', 'DL', 'GDI32']
            obj.linkflags = ['-mwindows']
            obj.use = [ 'libpbd', 'vstwin' ]
        else:
            obj.uselib = ['GIOMM', 'DL', 'OSX', 'XML', 'ARCHIVE', 'CURL']
            obj.use = [ 'libpbd' ]

    obj.includes  = [ '../pbd/', '../ardour/', '.' ]
    obj.defines = [
        '_POSIX_SOURCE',
        'USE_WS_PREFIX',
        'VST_SCANNER_APP',
        'PACKAGE="' + I18N_PACKAGE + str(bld.env['MAJOR']) + '"',
        'LIBARDOUR="' + bld.env['lwrcase_dirname'] + '"',
        ]
    if re.search ("bsd", sys.platform) != None:
        obj.defines.append('_POSIX_C_SOURCE=200809')
        obj.defines.append('_XOPEN_SOURCE=700')

    obj.install_path = os.path.join(bld.env['LIBDIR'])

=== libs/gtkmm2ext/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options
import os
import sys
import platform as PLATFORM

# Version of this package (even if built as a child)
MAJOR = '0'
MINOR = '8'
MICRO = '3'
GTKMM2EXT_VERSION = "%s.%s.%s" % (MAJOR, MINOR, MICRO)

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
GTKMM2EXT_LIB_VERSION = '0.8.3'

# Variables for 'waf dist'
APPNAME = 'gtkmm2ext'
VERSION = GTKMM2EXT_VERSION
I18N_PACKAGE = 'gtkmm2ext3'

gtkmm2ext_sources = [
        'actions.cc',
        'action_model.cc',
        'application.cc',
        'bindings.cc',
        'cairo_packer.cc',
        'cairo_widget.cc',
        'cell_renderer_color_selector.cc',
        'cell_renderer_pixbuf_multi.cc',
        'cell_renderer_pixbuf_toggle.cc',
        'colors.cc',
        'colorspace.cc',
        'cursors.cc',
        'debug.cc',
        'dndtreeview.cc',
        'emscale.cc',
        'gtk_ui.cc',
        'gtkapplication.c',
        'keyboard.cc',
        'menu_elems.cc',
        'persistent_tooltip.cc',
        'textviewer.cc',
        'treeutils.cc',
        'utils.cc',
        'visibility_tracker.cc',
        'window_proxy.cc',
        'window_title.cc'
]

# Mandatory variables
top = '.'
out = 'build'

path_prefix = 'libs/gtkmm2ext/'

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('compiler_cxx')
    autowaf.configure(conf)
    autowaf.check_pkg(conf, 'gtkmm-2.4', uselib_store='GTKMM', atleast_version='2.8')
    autowaf.check_pkg(conf, 'gtk+-2.0', uselib_store='GTK', atleast_version='2.12.1')


def build(bld):
    # operate on copy to avoid adding sources twice
    sources = list(gtkmm2ext_sources)

    if bld.is_defined ('INTERNAL_SHARED_LIBS'):
        obj              = bld.shlib(features = 'c cxx cshlib cxxshlib', source=sources)
        # defines for this library
        obj.defines      = [ 'LIBGTKMM2EXT_DLL_EXPORTS', 'ABSTRACT_UI_EXPORTS' ]
    else:
        obj              = bld.stlib(features = 'c cxx cstlib cxxstlib', source=sources)
        obj.cxxflags     = [ bld.env['compiler_flags_dict']['pic'] ]
        obj.defines      = [ ]

    obj.export_includes = ['.']
    obj.includes     = ['.']
    obj.name         = 'libgtkmm2ext'
    obj.target       = 'gtkmm2ext'
    obj.uselib       = 'GTKMM GTK XML'
    obj.use          = [ 'libpbd' ]
    obj.vnum         = GTKMM2EXT_LIB_VERSION
    obj.install_path = bld.env['LIBDIR']
    obj.defines     += [
                    'PACKAGE="' + I18N_PACKAGE + '"',
                    'LOCALEDIR="' + os.path.join(
                            os.path.normpath(bld.env['DATADIR']), 'locale') + '"']
    if sys.platform == 'darwin':
        obj.source += ['gtkapplication_quartz.mm', 'nsglview.mm']
        obj.uselib += ' OSX'
    else:
        obj.source += ['gtkapplication_x11.c']

    # i18n
    if bld.is_defined('ENABLE_NLS'):
        mo_files = bld.path.ant_glob('po/*.mo')
        for mo in mo_files:
            lang = os.path.basename(mo.srcpath()).replace('.mo', '')
            bld.install_as (os.path.join(os.path.normpath(bld.env['LOCALEDIR']), lang, 'LC_MESSAGES', I18N_PACKAGE + '.mo'),
                            mo)

def i18n(bld):
    autowaf.build_i18n(bld, top, 'libs/gtkmm2ext', I18N_PACKAGE, gtkmm2ext_sources,
                       'Paul Davis')

def i18n_pot(bld):
    autowaf.build_i18n_pot(bld, top, 'libs/gtkmm2ext', I18N_PACKAGE, gtkmm2ext_sources,
                       'Paul Davis')

def i18n_po(bld):
    autowaf.build_i18n_po(bld, top, 'libs/gtkmm2ext', I18N_PACKAGE, gtkmm2ext_sources,
                       'Paul Davis')

def i18n_mo(bld):
    autowaf.build_i18n_mo(bld, top, 'libs/gtkmm2ext', I18N_PACKAGE, gtkmm2ext_sources,
                       'Paul Davis')

def shutdown():
    autowaf.shutdown()

=== debian/changelog ===
ardour (1:6.5.0+ds0-1) unstable; urgency=medium

  * Upload to unstable.

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 13 Jan 2021 14:32:58 +0100

ardour (1:6.5.0+ds0-1~exp0) experimental; urgency=medium

  * New upstream version 6.5.0+ds0

  [ Dennis Braun ]
  * Update patchset
  * Bump S-V to 4.5.1
  * Bump d/watch version to 4

  [ Olivier Humbert ]
  * d/control:
    - create a ardour-lv2-plugins binary package definition
    - add a dep on it for the "ardour" binary package
  * d/rules: install the LV2s in the usual LV2 system dir
  * d/ardour-lv2-plugins.install: install the LV2s in a dedicated package
  * d/ardour.install: do not install the LV2s twice

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 13 Jan 2021 14:32:25 +0100

=== debian/control ===
Source: ardour
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Adrian Knoth <adi@drcomp.erfurt.thur.de>,
 Jaromír Mikeš <mira.mikes@seznam.cz>,
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
 Dennis Braun <d_braun@kabelmail.de>
Build-Depends:
 debhelper-compat (= 13),
 dh-buildinfo,
 gettext,
 intltool,
 itstool,
 libarchive-dev (>= 3.0.0),
 libboost-dev (>= 1.49.0),
 libcurl4-gnutls-dev (>= 7.25.0),
 libfftw3-dev (>= 3.3.1),
 liblrdf0-dev (>= 0.4.0),
 libserd-dev (>= 0.18.2~),
 libsord-dev (>= 0.12.0~),
 libsuil-dev (>= 0.6.10~),
 liblilv-dev,
 libsratom-dev (>= 0.4.2~),
 libsigc++-2.0-dev (>= 2.2.10),
 uuid-dev,
 libdbus-1-dev,
 libxml2-dev (>= 2.5.7),
 libcwiid-dev [linux-any],
 libcairomm-1.0-dev (>= 1.10.0),
 libgtkmm-2.4-dev (>= 2.24.2),
 libpangomm-1.4-dev (>= 2.28.4),
 libhidapi-dev,
 libusb-1.0-0-dev,
 ladspa-sdk (>= 1.1-2),
 libasound2-dev (>= 0.9.4) [linux-any],
 libpulse-dev,
 libaubio-dev (>= 0.3.2),
 libfluidsynth-dev,
 libjack-dev,
 liblo-dev (>= 0.26~),
 libltc-dev,
 libqm-dsp-dev,
 librubberband-dev,
 libsamplerate0-dev (>= 0.1.8),
 libsndfile1-dev (>= 1.0.25),
 libtag1-dev,
 libwebsockets-dev (>= 2.0.0),
 lv2-dev (>= 1.2.0),
 vamp-plugin-sdk (>=2.1),
 python3-setuptools,
 python3-isodate,
 python3-rdflib,
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://www.ardour.org/
Vcs-Git: https://salsa.debian.org/multimedia-team/ardour.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/ardour

Package: ardour
Architecture: any
Depends:
 ardour-data (>= ${source:Version}),
 ardour-data (<< ${source:Upstream-Version}.0~),
 ardour-lv2-plugins (>= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 ardour-video-timeline,
Suggests:
 ${shlibs:Suggests},
Replaces:
 ardour3 (<< 1:3.5),
Breaks:
 ardour3 (<< 1:3.5),
Description: the digital audio workstation
 Ardour is a multichannel hard disk recorder (HDR) and digital audio
 workstation (DAW).  It can be used to control, record, edit and run
 complex audio setups.
 .
 Ardour supports pro-audio interfaces
 through the ALSA project, which provides high quality, well designed
 device drivers and API's for audio I/O under Linux. Any interface
 supported by ALSA can be used with Ardour. This includes the
 all-digital 26 channel RME Hammerfall, the Midiman Delta 1010 and many
 others.
 .
 Ardour has support for 24 bit samples
 using floating point internally, non-linear editing with unlimited undo,
 a user-configurable mixer, MTC master/slave capabilities, MIDI hardware
 control surface compatibility.
 .
 It supports MIDI
 Machine Control, and so can be controlled from any MMC controller and
 many modern digital mixers.
 .
 Ardour contains a
 powerful multitrack audio editor/arranger that is completely
 non-destructive and capable of all standard non-linear editing
 operations (insert, replace, delete, move, trim, select,
 cut/copy/paste). The editor has unlimited undo/redo capabilities and can
 save independent "versions" of a track or an entire piece
 .
 Ardour's editor supports the community-developed LADSPA
 plugin standard.  Arbitrary chains of plugins can be attached to any
 portion of a track.  Every mixer strip can have any number of inputs
 and outputs, not just mono, stereo or 5.1.  An N-way panner is
 included, with support for various panning models.  Pre- and post-fader
 sends exist, each with their own gain and pan controls.  Every mixer
 strip acts as its own bus, and thus the bus count in Ardour is
 unlimited.  You can submix any number of strips into another
 strip.
 .
 Ardour's channel capacity is limited only
 by the number on your audio interface and the ability of your disk
 subsystem to stream the data back and forth.
 .
 JACK
 (the JACK Audio Connection Kit) is used for all audio I/O, permitting
 data to be exchanged in perfect samplesync with other applications
 and/or hardware audio interfaces.
 .
 Ardour is
 sample rate and size neutral - any hardware formats from 8 to 32 bits,
 and rates from 8kHz to 192kHz.  Internal processing in 32/64 bit IEEE
 floating point format.
 .
 Further information can be
 found at <https://ardour.org/>.

Package: ardour-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: ardour
Breaks: ardour (<= 1:4.2~dfsg-1),
 ardour3 (<< 1:3.5),
Replaces: ardour (<= 1:4.2~dfsg-1),
 ardour3 (<< 1:3.5),
Description: digital audio workstation (data)
 Ardour is a multichannel hard disk recorder (HDR) and digital audio
 workstation (DAW).  It can be used to control, record, edit and run
 complex audio setups.
 .
 This package contains the architecture-independent data files.

Package: ardour-video-timeline
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
 xjadeo (>= 0.6.4),
 harvid (>= 0.7.0),
 ffmpeg (>= 7:1.2),
Description: digital audio workstation - video timeline
 Ardour is a multichannel hard disk recorder (HDR) and digital audio
 workstation (DAW).  It can be used to control, record, edit and run
 complex audio setups.
 .
 This is a dependency package to add video timeline capabilities to ardour.

Package: ardour-lv2-plugins
Architecture: any
Depends: ${misc:Depends}
Provides: lv2-plugin
Description: digital audio workstation - lv2 plugins set
 Ardour is providing a set of LV2 plugins :
 .
 * a-comp.lv2: a compressor (mono & stereo versions)
 .
 * a-exp.lv2: an expander (mono & stereo versions)
 .
 * a-delay.lv2: a delay (mono version)
 .
 * a-eq.lv2: an equaliser (mono version)
 .
 * a-reverb.lv2: a reverberation (stereo version)
 .
 * a-fluidsynth.lv2: a SF2 player (stereo version)
 .
 * reasonablesynth.lv2: a reasonnably good piano synth (stereo version)
 .
 This package allows these to be used by other hosts as well.

=== debian/rules ===
#!/usr/bin/make -f
#
# Robert Jordens <jordens@debian.org>
# © 2019, IOhannes m zmölnig <umlaeute@debian.org>
# © 2020, Olivier Humbert <trebmuh@tuxfamily.org>
#
# This software may be used and distributed according to the terms
# of the GNU General Public License, incorporated herein by reference.

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/buildflags.mk
BUILD_DATE:=$(shell date -u -d "@$(SOURCE_DATE_EPOCH)" +"%F")

########### WAF options ############
waf-light = python3 $(CURDIR)/debian/waf/waf-light
waf-configure-options = \
	--lxvst \
	--freedesktop \
	--configdir=/etc/ \
	--noconfirm \
	--prefix=/usr/ \
	--no-phone-home \
	--use-external-libs \
	--optimize \
	--cxx11 \
	--ptformat \
	--lv2dir=/usr/lib/lv2 \
	$(empty)


DIST_TARGET = none
ifneq (,$(findstring i386,$(DEB_BUILD_ARCH)))
	DIST_TARGET = i686
endif
ifneq (,$(findstring amd64,$(DEB_BUILD_ARCH)))
	DIST_TARGET = x86_64
endif

BACKENDS = jack,dummy
ifneq (,$(findstring linux,$(DEB_HOST_ARCH_OS)))
# ALSA Backend is only available on Linux
	BACKENDS = jack,alsa,dummy,pulseaudio
else
	waf-configure-options += \
		--no-fpu-optimization \
		$(empty)
endif

ARDOUR_LIBRARY_PATH := /usr/lib/ardour6/

waf-configure-options += \
	--with-backends=$(BACKENDS) \
	--dist-target=$(DIST_TARGET) \
	$(empty)

DEB_WAF_INVOKE = \
	CPPFLAGS="$(CPPFLAGS)" \
	CFLAGS="$(CFLAGS)" \
	CXXFLAGS="$(CXXFLAGS)" \
	LDFLAGS="$(LDFLAGS) -Wl,--as-needed" \
	$(waf-light) -v --destdir=$(CURDIR)/debian/tmp

deb_revision := libs/ardour/revision.cc
waf_extras := debian/waf/waflib/extras/autowaf.py debian/waf/waflib/extras/misc.py

########### build overrides options ############
%:
	dh $@

override_dh_auto_build: genfiles
	$(DEB_WAF_INVOKE) configure $(waf-configure-options)
	$(DEB_WAF_INVOKE) build i18n_mo

override_dh_auto_install: override_dh_auto_build manpages genfiles
	$(DEB_WAF_INVOKE) install
	for res in 16 22 32 48; do \
		mkdir -p $(CURDIR)/debian/ardour/usr/share/icons/hicolor/$${res}x$${res}/mimetypes; \
		cp $(CURDIR)/gtk2_ardour/icons/application-x-ardour_$${res}px.png \
			$(CURDIR)/debian/ardour/usr/share/icons/hicolor/$${res}x$${res}/mimetypes/application-x-ardour.png ; \
	done

## ardour includes a couple of private lib*.so files, which make
## dh_makeshlibs emit a useless call to `ldconfig` in the postinst script.
## since we don't have any public libraries, we just suppress that call.
override_dh_makeshlibs:
	dh_makeshlibs --no-scripts
override_dh_shlibdeps:
	dh_shlibdeps -- -l$(CURDIR)/debian/ardour/$(ARDOUR_LIBRARY_PATH)

override_dh_clean: manpageclean
	rm -f .lock-wscript .lock-waf_linux2_build
	find . -name "*.pyc" -delete || true
	find . -name "*.mo" -delete || true
	rm -rf build
	rm -f \
		gtk2_ardour/version.cc\
		gtk2_ardour/version.h\
		gtk2_ardour/ardour.appdata.xml.in\
		libs/ardour/ardour/version.h\
		libs/ardour/config_text.cc\
		libs/ardour/svn_revision.cc\
		libs/ardour/version.cc\
		$(deb_revision)\
		libs/gtkmm2ext/gtkmm2ext/version.h\
		libs/gtkmm2ext/version.cc\
		libs/midi++2/midi++/version.h\
		libs/midi++2/version.cc\
		libs/pbd/pbd/version.h\
		libs/pbd/version.cc\
		$(empty)
	dh_clean

########### build intermediates ############
.PHONY: genfiles
genfiles: $(deb_revision) $(waf_extras)

$(deb_revision):
	echo '#include "ardour/revision.h"' > $@
	echo "namespace ARDOUR { const char* revision = \"$(subst +,~,$(DEB_VERSION_UPSTREAM_REVISION))\"; const char* date = \"$(BUILD_DATE)\"; }" >> $@

debian/waf/waflib/extras/%: tools/%
	cp $< $@

MANPAGES = ardour6-copy-mixer.1 ardour6-export.1 ardour6-fix_bbtppq.1 \
	ardour6-new_empty_session.1 ardour6-new_session.1
.PHONY: manpages manpageclean
$(MANPAGES): debian/ardour6-utils.1
	cp $^ $@
manpages: $(MANPAGES)
manpageclean:
	rm -f $(MANPAGES)

################ d/copyright helper ##############
DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
        \.git/.*|debian/.*|.*\.ico|.*\.icns|.*\.wav|.*\.flac|.*\.ogg|.*\.touchosc

.PHONY: licensecheck
licensecheck:
	licensecheck --deb-machine \
		-i "^($(DEB_COPYRIGHT_CHECK_IGNORE_REGEX))$$" \
		-r * \
		> debian/copyright_newhints
	cmp debian/copyright_hints debian/copyright_newhints \
		&& rm debian/copyright_newhints

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/Ardour-(\d\S*)\.tar\.bz2/ardour-$1\.tar\.bz2/,uversionmangle=s/-pre/~pre/;s/-rc/~rc/,dversionmangle=s/~(dfsg|repack|ds).*//,oversionmangle=s/$/+ds0/ \
  https://community.ardour.org/src/ .*/Ardour-(\d\S*)\.tar\.bz2
